var _inherits = require('babel-runtime/helpers/inherits').default;

var _classCallCheck = require('babel-runtime/helpers/class-call-check').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _resourceProcessorBase = require('./resource-processor-base');

var _resourceProcessorBase2 = _interopRequireDefault(_resourceProcessorBase);

var _utilsStringTrim = require('../../utils/string-trim');

var _utilsStringTrim2 = _interopRequireDefault(_utilsStringTrim);

var ManifestProcessor = (function (_ResourceProcessorBase) {
    _inherits(ManifestProcessor, _ResourceProcessorBase);

    function ManifestProcessor() {
        _classCallCheck(this, ManifestProcessor);

        _ResourceProcessorBase.apply(this, arguments);
    }

    ManifestProcessor.prototype.processResource = function processResource(manifest, ctx, charset, urlReplacer) {
        var lines = manifest.split('\n');

        for (var i = 0; i < lines.length; i++) {
            var line = _utilsStringTrim2.default(lines[i]);

            if (line && line !== 'CACHE MANIFEST' && line !== 'NETWORK:' && line !== 'FALLBACK:' && line !== 'CACHE:' && line[0] !== '#' && line !== '*') {

                var isFallbackItem = line.indexOf(' ') !== -1;

                if (isFallbackItem) {
                    var urls = line.split(' ');

                    lines[i] = urlReplacer(urls[0]) + ' ' + urlReplacer(urls[1]);
                } else lines[i] = urlReplacer(line);
            }
        }

        return lines.join('\n');
    };

    ManifestProcessor.prototype.shouldProcessResource = function shouldProcessResource(ctx) {
        return ctx.contentInfo.isManifest;
    };

    return ManifestProcessor;
})(_resourceProcessorBase2.default);

exports.default = new ManifestProcessor();
module.exports = exports.default;