var _taggedTemplateLiteralLoose = require('babel-runtime/helpers/tagged-template-literal-loose').default;

var _inherits = require('babel-runtime/helpers/inherits').default;

var _classCallCheck = require('babel-runtime/helpers/class-call-check').default;

var _Symbol = require('babel-runtime/core-js/symbol').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard').default;

exports.__esModule = true;

var _templateObject = _taggedTemplateLiteralLoose(['\n    <script type="text/javascript" class="', '">\n        if (window["%hammerhead%"])\n            window["%hammerhead%"].sandbox.node.raiseBodyCreatedEvent();\n\n        var script = document.currentScript || document.scripts[document.scripts.length - 1];\n        script.parentNode.removeChild(script);\n    </script>\n'], ['\n    <script type="text/javascript" class="', '">\n        if (window["%hammerhead%"])\n            window["%hammerhead%"].sandbox.node.raiseBodyCreatedEvent();\n\n        var script = document.currentScript || document.scripts[document.scripts.length - 1];\n        script.parentNode.removeChild(script);\n    </script>\n']);

var _parse5 = require('parse5');

var _parse52 = _interopRequireDefault(_parse5);

var _dedent = require('dedent');

var _dedent2 = _interopRequireDefault(_dedent);

var _shadowUiClassName = require('../../shadow-ui/class-name');

var _shadowUiClassName2 = _interopRequireDefault(_shadowUiClassName);

var _dom = require('../dom');

var _dom2 = _interopRequireDefault(_dom);

var _domParse5DomAdapter = require('../dom/parse5-dom-adapter');

var _domParse5DomAdapter2 = _interopRequireDefault(_domParse5DomAdapter);

var _resourceProcessorBase = require('./resource-processor-base');

var _resourceProcessorBase2 = _interopRequireDefault(_resourceProcessorBase);

var _utilsParse5 = require('../../utils/parse5');

var parse5Utils = _interopRequireWildcard(_utilsParse5);

var _utilsGetBom = require('../../utils/get-bom');

var _utilsGetBom2 = _interopRequireDefault(_utilsGetBom);

var BODY_CREATED_EVENT_SCRIPT = _dedent2.default(_templateObject, _shadowUiClassName2.default.script);

var PageProcessor = (function (_ResourceProcessorBase) {
    _inherits(PageProcessor, _ResourceProcessorBase);

    function PageProcessor() {
        _classCallCheck(this, PageProcessor);

        _ResourceProcessorBase.call(this);

        this.parser = new _parse52.default.Parser();

        this.RESTART_PROCESSING = _Symbol();
        this.PARSED_BODY_CREATED_EVENT_SCRIPT = this.parser.parseFragment(BODY_CREATED_EVENT_SCRIPT).childNodes[0];

        this.serializer = new _parse52.default.Serializer();
    }

    PageProcessor._getPageProcessingOptions = function _getPageProcessingOptions(ctx, urlReplacer) {
        return {
            crossDomainProxyPort: ctx.serverInfo.crossDomainPort,
            isIframe: ctx.isIframe,
            stylesheets: ctx.getInjectableStyles(),
            scripts: ctx.getInjectableScripts(),
            urlReplacer: urlReplacer,
            isIframeWithImageSrc: ctx.contentInfo && ctx.contentInfo.isIframeWithImageSrc
        };
    };

    PageProcessor._getPageMetas = function _getPageMetas(metaEls, domAdapter) {
        var metas = [];

        for (var i = 0; i < metaEls.length; i++) {
            metas.push({
                httpEquiv: domAdapter.getAttr(metaEls[i], 'http-equiv'),
                content: domAdapter.getAttr(metaEls[i], 'content'),
                charset: domAdapter.getAttr(metaEls[i], 'charset')
            });
        }

        return metas;
    };

    PageProcessor._addPageResources = function _addPageResources(head, processingOptions) {
        var result = [];

        if (processingOptions.stylesheets) {
            processingOptions.stylesheets.forEach(function (stylesheetUrl) {
                result.push(parse5Utils.createElement('link', [{ name: 'rel', value: 'stylesheet' }, { name: 'type', value: 'text/css' }, { name: 'class', value: _shadowUiClassName2.default.uiStylesheet }, { name: 'href', value: stylesheetUrl }]));
            });
        }

        if (processingOptions.scripts) {
            processingOptions.scripts.forEach(function (scriptUrl) {
                result.push(parse5Utils.createElement('script', [{ name: 'type', value: 'text/javascript' }, { name: 'class', value: _shadowUiClassName2.default.script }, { name: 'charset', value: 'UTF-8' }, { name: 'src', value: scriptUrl }]));
            });
        }

        for (var i = result.length; i--; i > -1) parse5Utils.insertElement(result[i], head);
    };

    PageProcessor._addCharsetInfo = function _addCharsetInfo(head, charset) {
        parse5Utils.insertElement(parse5Utils.createElement('meta', [{ name: 'class', value: _shadowUiClassName2.default.charset }, { name: 'charset', value: charset }]), head);
    };

    PageProcessor._changeMetas = function _changeMetas(metas, domAdapter) {
        if (metas) {
            metas.forEach(function (meta) {
                // TODO: Figure out how to emulate the tag behavior.
                if (domAdapter.getAttr(meta, 'name') === 'referrer' && domAdapter.getAttr(meta, 'content') === 'origin') parse5Utils.removeNode(meta);
                // NOTE: Remove the existing ‘compatible’ meta tag and add a new one at the beginning of the head.
                if (domAdapter.getAttr(meta, 'http-equiv') === 'X-UA-Compatible') parse5Utils.removeNode(meta);
            });
        }
    };

    PageProcessor._addCompatibilityMeta = function _addCompatibilityMeta(head) {
        parse5Utils.insertElement(parse5Utils.createElement('meta', [{ name: 'http-equiv', value: 'X-UA-Compatible' }, { name: 'content', value: 'IE=edge' }]), head);
    };

    PageProcessor._prepareHtml = function _prepareHtml(html, processingOpts) {
        if (processingOpts && processingOpts.iframeImageSrc) return '<html><body><img src="' + processingOpts.iframeImageSrc + '" /></body></html>';

        return html;
    };

    PageProcessor.prototype._addBodyCreatedEventScript = function _addBodyCreatedEventScript(body) {
        parse5Utils.insertElement(this.PARSED_BODY_CREATED_EVENT_SCRIPT, body);
    };

    PageProcessor.prototype.shouldProcessResource = function shouldProcessResource(ctx) {
        return ctx.isPage || ctx.contentInfo.isIframeWithImageSrc;
    };

    PageProcessor.prototype.processResource = function processResource(html, ctx, charset, urlReplacer, processingOpts) {
        var pageProcessor = this;

        processingOpts = processingOpts || PageProcessor._getPageProcessingOptions(ctx, urlReplacer);

        var bom = _utilsGetBom2.default(html);

        html = bom ? html.replace(bom, '') : html;

        PageProcessor._prepareHtml(html, processingOpts);

        var root = this.parser.parse(html);
        var domAdapter = new _domParse5DomAdapter2.default(processingOpts.isIframe, processingOpts.crossDomainProxyPort);
        var elements = parse5Utils.findElementsByTagNames(root, ['base', 'meta', 'head', 'body']);
        var base = elements.base ? elements.base[0] : null;
        var baseUrl = base ? domAdapter.getAttr(base, 'href') : '';
        var metas = elements.meta;
        var head = elements.head[0];
        var body = elements.body[0];

        if (metas && charset.fromMeta(PageProcessor._getPageMetas(metas, domAdapter))) return this.RESTART_PROCESSING;

        var iframeHtmlProcessor = function (iframeHtml, callback) {
            var storedIsIframe = processingOpts.isIframe;

            processingOpts.isIframe = true;

            var result = pageProcessor.processResource(iframeHtml, ctx, charset, urlReplacer, processingOpts);

            processingOpts.isIframe = storedIsIframe;

            callback(result);
        };

        var domProcessor = new _dom2.default(domAdapter);
        var replacer = function (resourceUrl, resourceType, charsetAttrValue) {
            return urlReplacer(resourceUrl, resourceType, charsetAttrValue, baseUrl);
        };

        domProcessor.on(domProcessor.HTML_PROCESSING_REQUIRED_EVENT, iframeHtmlProcessor);
        parse5Utils.walkElements(root, function (el) {
            return domProcessor.processElement(el, replacer);
        });
        domProcessor.off(domProcessor.HTML_PROCESSING_REQUIRED_EVENT, iframeHtmlProcessor);

        PageProcessor._addPageResources(head, processingOpts, domAdapter);
        this._addBodyCreatedEventScript(body, domAdapter);
        PageProcessor._changeMetas(metas, domAdapter);
        PageProcessor._addCharsetInfo(head, charset.get(), domAdapter);
        PageProcessor._addCompatibilityMeta(head, domAdapter);

        return (bom || '') + this.serializer.serialize(root);
    };

    return PageProcessor;
})(_resourceProcessorBase2.default);

exports.default = new PageProcessor();
module.exports = exports.default;