var _inherits = require('babel-runtime/helpers/inherits').default;

var _classCallCheck = require('babel-runtime/helpers/class-call-check').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _resourceProcessorBase = require('./resource-processor-base');

var _resourceProcessorBase2 = _interopRequireDefault(_resourceProcessorBase);

var _lruCache = require('lru-cache');

var _lruCache2 = _interopRequireDefault(_lruCache);

var _script = require('../script');

var ScriptResourceProcessor = (function (_ResourceProcessorBase) {
    _inherits(ScriptResourceProcessor, _ResourceProcessorBase);

    function ScriptResourceProcessor() {
        _classCallCheck(this, ScriptResourceProcessor);

        _ResourceProcessorBase.call(this);

        this.jsCache = new _lruCache2.default({
            // NOTE: Max cache size is 50 MBytes.
            max: 50 * 1024 * 1024,

            length: function (n) {
                // NOTE: 1 char ~ 1 byte.
                return n.length;
            }
        });
    }

    ScriptResourceProcessor.prototype.processResource = function processResource(script) {
        var processedScript = this.jsCache.get(script);

        if (!processedScript) {
            processedScript = _script.processScript(script, true, false);
            this.jsCache.set(script, processedScript);
        }

        return processedScript;
    };

    ScriptResourceProcessor.prototype.shouldProcessResource = function shouldProcessResource(ctx) {
        return ctx.contentInfo.isScript && !ctx.isXhr;
    };

    return ScriptResourceProcessor;
})(_resourceProcessorBase2.default);

exports.default = new ScriptResourceProcessor();
module.exports = exports.default;