exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _nodeBuilder = require('../node-builder');

var _toolsEsotope = require('../tools/esotope');

var _instrumented = require('../instrumented');

// Transform:
// obj[prop] = value -->
// __set$(object, prop, value)

exports.default = {
    nodeReplacementRequireTransform: true,

    nodeTypes: [_toolsEsotope.Syntax.AssignmentExpression],

    condition: function (node) {
        var left = node.left;

        if (node.operator === '=' && left.type === _toolsEsotope.Syntax.MemberExpression && left.computed) return left.property.type === _toolsEsotope.Syntax.Literal ? _instrumented.shouldInstrumentProperty(left.property.value) : true;

        return false;
    },

    run: function (node) {
        return _nodeBuilder.createComputedPropertySetWrapper(node.left.property, node.left.object, node.right);
    }
};
module.exports = exports.default;