var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _nodeBuilder = require('../node-builder');

var _internalLiteral = require('../internal-literal');

var _internalLiteral2 = _interopRequireDefault(_internalLiteral);

var _toolsEsotope = require('../tools/esotope');

function isDocumentWriteStmt(stmt) {
    return stmt.type === _toolsEsotope.Syntax.ExpressionStatement && stmt.expression.type === _toolsEsotope.Syntax.CallExpression && stmt.expression.callee.type === _toolsEsotope.Syntax.MemberExpression && (stmt.expression.callee.property.name === 'write' || stmt.expression.callee.property.name === 'writeln');
}

function getDocumentWriteStmtIndices(stmts) {
    var indices = [];

    for (var i = 0; i < stmts.length; i++) {
        if (isDocumentWriteStmt(stmts[i])) indices.push(i);
    }

    return indices;
}

// Transform:

// obj.write(html); obj.writeln(html);  -->
// obj.write(html, __begin$); obj.writeln(html, __end$);

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_toolsEsotope.Syntax.BlockStatement, _toolsEsotope.Syntax.Program],

    condition: function (node) {
        return getDocumentWriteStmtIndices(node.body).length > 1;
    },

    run: function (node) {
        var indices = getDocumentWriteStmtIndices(node.body);
        var firstExpr = node.body[indices[0]].expression;
        var lastExpr = node.body[indices[indices.length - 1]].expression;

        firstExpr.arguments.push(_nodeBuilder.createStringLiteral(_internalLiteral2.default.documentWriteBegin));
        lastExpr.arguments.push(_nodeBuilder.createStringLiteral(_internalLiteral2.default.documentWriteEnd));

        return null;
    }
};
module.exports = exports.default;