var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _instruction = require('../instruction');

var _instruction2 = _interopRequireDefault(_instruction);

var _nodeBuilder = require('../node-builder');

var _toolsEsotope = require('../tools/esotope');

// Transform:
// var foo = eval; foo = eval; { _eval: eval }; return eval;
// -->
// var foo = _get$Eval(eval); foo = _get$Eval(eval); { _eval: _get$Eval(eval) }; return _get$Eval(eval);

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_toolsEsotope.Syntax.Identifier],

    condition: function (node, parent) {
        if (node.name === 'eval') {
            // Skip: eval()
            if (parent.type === _toolsEsotope.Syntax.CallExpression && parent.callee === node) return false;

            // Skip: window.eval, eval.call
            if (parent.type === _toolsEsotope.Syntax.MemberExpression) return false;

            // Skip: function (eval) { ... } || function func(eval) { ... }
            if ((parent.type === _toolsEsotope.Syntax.FunctionExpression || parent.type === _toolsEsotope.Syntax.FunctionDeclaration) && parent.params.indexOf(node) !== -1) return false;

            // Skip: { eval: value }
            if (parent.type === _toolsEsotope.Syntax.Property && parent.key === node) return false;

            // Skip: eval = value
            if (parent.type === _toolsEsotope.Syntax.AssignmentExpression && parent.left === node) return false;

            // Skip: var eval = value;
            if (parent.type === _toolsEsotope.Syntax.VariableDeclarator && parent.id === node) return false;

            // Skip: eval++ || eval-- || ++eval || --eval
            if (parent.type === _toolsEsotope.Syntax.UpdateExpression && parent.operator === '++' || parent.operator === '--') return false;

            // Skip already transformed: __get$Eval(eval)
            if (parent.type === _toolsEsotope.Syntax.CallExpression && parent.callee.name === _instruction2.default.getEval) return false;

            return true;
        }

        return false;
    },

    run: _nodeBuilder.createGetEvalMethCall
};
module.exports = exports.default;