exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _nodeBuilder = require('../node-builder');

var _toolsEsotope = require('../tools/esotope');

// Transform:
// location.field; location[field] -->
// __get$Loc(location).field; __get$Loc(location)[field];

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_toolsEsotope.Syntax.MemberExpression],

    condition: function (node, parent) {
        // Skip: for(location.field in obj)
        if (parent.type === _toolsEsotope.Syntax.ForInStatement && parent.left === node) return false;

        return node.object.name === 'location';
    },

    run: function (node) {
        node.object = _nodeBuilder.createLocationGetWrapper();

        return null;
    }
};
module.exports = exports.default;