exports.__esModule = true;
exports.isPage = isPage;
exports.isCSSResource = isCSSResource;
exports.isScriptResource = isScriptResource;
exports.isManifest = isManifest;
exports.isJSON = isJSON;
// Const
var JSON_MIME = 'application/json';
var MANIFEST_MIME = 'text/cache-manifest';
var CSS_MIME = 'text/css';

var PAGE_MIMES = ['text/html', 'application/xhtml+xml', 'application/xml', 'application/x-ms-application'];

var SCRIPT_MIMES = ['application/javascript', 'text/javascript', 'application/x-javascript'];

// Content type

function isPage(header) {
    header = header.toLowerCase();

    return PAGE_MIMES.some(function (mime) {
        return header.indexOf(mime) > -1;
    });
}

function isCSSResource(contentTypeHeader, acceptHeader) {
    return contentTypeHeader.toLowerCase().indexOf(CSS_MIME) > -1 || acceptHeader.toLowerCase() === CSS_MIME;
}

function isScriptResource(contentTypeHeader, acceptHeader) {
    contentTypeHeader = contentTypeHeader.toLowerCase();
    acceptHeader = acceptHeader.toLowerCase();

    return SCRIPT_MIMES.some(function (mime) {
        return contentTypeHeader.indexOf(mime) > -1;
    }) || SCRIPT_MIMES.indexOf(acceptHeader) > -1;
}

function isManifest(contentTypeHeader) {
    return contentTypeHeader.toLowerCase().indexOf(MANIFEST_MIME) > -1;
}

function isJSON(contentTypeHeader) {
    return contentTypeHeader.toLowerCase().indexOf(JSON_MIME) > -1;
}